/********************************************************************/
/*	Project 	: tbVROMݐvO					*/
/*	Description : main program										*/
/*  Original	: Renesas Flash Memory Write/Erase Application Note */
/*	CPU 	 	: H8S2633											*/
/*  CPU Clock   : 24.576MHz 										*/
/*	Date	 	: 070327											*/
/*	Author	 	: Hideo Nakamura									*/
/********************************************************************/

/************************************************************/
/* Symbol Definition */
/************************************************************/
struct BIT {
unsigned char b7:1; /* bit7 */
unsigned char b6:1; /* bit6 */
unsigned char b5:1; /* bit5 */
unsigned char b4:1; /* bit4 */
unsigned char b3:1; /* bit3 */
unsigned char b2:1; /* bit2 */
unsigned char b1:1; /* bit1 */
unsigned char b0:1; /* bit0 */
};

/* 9.2 X[u/vO */
#define FLMCR1 *(volatile unsigned char *)0xFFFFA8 /* Flash Memory Control Register 1 */
#define FLMCR1_BIT (*(volatile struct BIT *)0xFFFFA8) /* Flash Memory Control Register 1 */
#define FWE FLMCR1_BIT.b7 /* Flash Write Enable */
#define SWE1 FLMCR1_BIT.b6 /* Software Write Enable */
#define ESU1 FLMCR1_BIT.b5 /* Erase Setup */
#define PSU1 FLMCR1_BIT.b4 /* Program Setup */
#define EV1 FLMCR1_BIT.b3 /* Erase Verify */
#define PV1 FLMCR1_BIT.b2 /* Program Verify */
#define E1 FLMCR1_BIT.b1 /* Erase */
#define P1 FLMCR1_BIT.b0
#define FLMCR2 *(volatile unsigned char *)0xFFFFA9 /* Flash Memory Control Register 2 */
#define FLMCR2_BIT (*(volatile struct BIT *)0xFFFFA9) /* Flash Memory Control Register 2 */
#define FLER FLMCR2_BIT.b7 /* FLER */
#define EBR1 *(volatile unsigned char *)0xFFFFAA /* Erase Block Register 1 */
#define EBR2 *(volatile unsigned char *)0xFFFFAB /* Erase Block Register 2 */
#define RAMER *(volatile unsigned char *)0xFFFEDB /* RAM Emulation Register */
#define FLPWCR *(volatile unsigned char *)0xFFFFAC /* Flash Memory Power Control Register */
#define SCRX_BIT (*(volatile struct BIT *)0xFFFDB4) /* Serial Control Register X */
#define FLSHE SCRX_BIT.b3 /* Flash Memory Control Register Enable */
#define TCSRW_0 *(volatile unsigned short *)0xFFFF74 /* Timer Control/Status Register W */
#define TCNTW_0 *(volatile unsigned short *)0xFFFF74 /* Timer Counter W */
#define RSTCSR *(volatile unsigned short *)0xFFFF76 /* Timer Control/Status Register W */
#define IER *(volatile unsigned char *)0xFFFE14 /* IRQ Enable Register */
#define ADCR *(volatile unsigned char *)0xFFFF99 /* A/D Control Register */
#define PFDDR *(volatile unsigned char *)0xFFFE3E /* Port F Data Direction Register */
#define PFDR *(volatile unsigned char *)0xFFFF0E /* Port F Data Register */
#define TCSRW_0 *(volatile unsigned short *)0xFFFF74 /* Timer */
#define TCNTW_0 *(volatile unsigned short *)0xFFFF74 /* Timer Counter W */

/* communication */
#define SMR_0 *(volatile unsigned char *)0xFFFF78 /* Serial Mode Register */
#define BRR_0 *(volatile unsigned char *)0xFFFF79 /* Bit Rate Register */
#define SCR_0 *(volatile unsigned char *)0xFFFF7A /* Serial Control Register 3 */
#define SCR_0_BIT (*(volatile struct BIT *)0xFFFF7A) /* Serial Control Register 3 */
#define TE_0 SCR_0_BIT.b5 /* Transmit Enable */
#define RE_0 SCR_0_BIT.b4 /* Receive Enable */
#define CKE1_0 SCR_0_BIT.b1 /* Clock Enable 1 */
#define CKE0_0 SCR_0_BIT.b0 /* Clock Enable 0 */
#define TDR_0 *(volatile unsigned char *)0xFFFF7B /* Transmit Data Register */
#define SSR_0 *(volatile unsigned char *)0xFFFF7C /* Serial Status Register */
#define SSR_0_BIT (*(volatile struct BIT *)0xFFFF7C) /* Serial Status Register */
#define TDRE_0 SSR_0_BIT.b7 /* Transmit Data Register Empty */
#define RDRF_0 SSR_0_BIT.b6 /* Receive Data Register Full */
#define ORER_0 SSR_0_BIT.b5 /* Overrun Erorr */
#define FER_0 SSR_0_BIT.b4 /* Framing Erorr */
#define PER_0 SSR_0_BIT.b3 /* Parity Erorr */
#define TEND_0 SSR_0_BIT.b2 /* Transmit End */
#define RDR_0 *(volatile unsigned char *)0xFFFF7D /* Receive data Register */
#define SCMR *(volatile unsigned char *)0xFFFF7E /* Smart Card Mode Register */
#define SEMR_0 *(volatile unsigned char *)0xFFFDF8 /* Serial Expansion Mode Register */
#define MSTPCRB *(volatile unsigned char *)0xFFFDE9 /* Module Stop Control Registers C */

#define SMR_2 *(volatile unsigned char *)0xFFFF88 /* Serial Mode Register */
#define BRR_2 *(volatile unsigned char *)0xFFFF89 /* Bit Rate Register */
#define SCR_2 *(volatile unsigned char *)0xFFFF8A /* Serial Control Register 3 */
#define SCR_2_BIT (*(volatile struct BIT *)0xFFFF8A) /* Serial Control Register 3 */
#define TE_2 SCR_2_BIT.b5 /* Transmit Enable */
#define RE_2 SCR_2_BIT.b4 /* Receive Enable */
#define CKE1_2 SCR_2_BIT.b1 /* Clock Enable 1 */
#define CKE0_2 SCR_2_BIT.b0 /* Clock Enable 0 */
#define TDR_2 *(volatile unsigned char *)0xFFFF8B /* Transmit Data Register */
#define SSR_2 *(volatile unsigned char *)0xFFFF8C /* Serial Status Register */
#define SSR_2_BIT (*(volatile struct BIT *)0xFFFF8C) /* Serial Status Register */
#define TDRE_2 SSR_2_BIT.b7 /* Transmit Data Register Empty */
#define RDRF_2 SSR_2_BIT.b6 /* Receive Data Register Full */
#define ORER_2 SSR_2_BIT.b5 /* Overrun Erorr */
#define FER_2 SSR_2_BIT.b4 /* Framing Erorr */
#define PER_2 SSR_2_BIT.b3 /* Parity Erorr */
#define TEND_2 SSR_2_BIT.b2 /* Transmit End */
#define RDR_2 *(volatile unsigned char *)0xFFFF8D /* Receive data Register */

#define OK 0
#define NG 1

/************************************************************/
/* Function define */
/************************************************************/
char fwrite128( unsigned char *wt_buf, unsigned char *wt_adr, unsigned short WT_COUNT );
void fwrite_rename( unsigned char *buf, unsigned char *w_adr, unsigned short ptime );
char fwritevf( unsigned short *owbuff, unsigned short *buff , unsigned short *wvf_buf, unsigned short *wvf_adr );
void main( void );
void com_init( void );
void trsnbyte ( unsigned char *tdt, unsigned char dtno );
unsigned char rcv1byte ( void );
void trs1byte ( unsigned char tdt );
void rcvnbyte ( unsigned char *ram, unsigned char dtno );

/************************************************************/
/* ROM define 												*/
/************************************************************/
/****** WAIT TIME *******************************************/
#define MHZ 3							// for HS2633: Clock ɂ蒲Kv
#define KEISU1 3 						/* 1Loop 3Step <-- DEC.B(1)+BNE(2) */
#define KEISU2 5 						/* 1Loop 5Step <-- INC.W(1)+CMP.W(2)+BCS(2) */
#define WLOOP1 1*MHZ/KEISU1+1 			/* LOOP WAIT TIME 1us */
#define WLOOP2 2*MHZ/KEISU1+1
#define WLOOP4 4*MHZ/KEISU1+1
#define WLOOP5 5*MHZ/KEISU1+1
#define WLOOP10 10*MHZ/KEISU1+1
#define WLOOP20 20*MHZ/KEISU1+1
#define WLOOP50 50*MHZ/KEISU2+1
#define WLOOP100 100*MHZ/KEISU2+1
#define TIME10 10*MHZ/KEISU1+1 			/* WRITE WAIT TIME */
#define TIME30 30*MHZ/KEISU1+1 			/* WRITE WAIT TIME */
#define TIME200 200*MHZ/KEISU2+1 		/* WRITE WAIT TIME */
#define TIME10000 10000*MHZ/KEISU2+1 	/* ERASE WAIT TIME */
#define WNG 2
#define OW_COUNT 6 						/* Over Write Count */

/************************************************************/
/* delay */	
/************************************************************/
void delay ( unsigned short loop)
{
	unsigned short i;

	for(i = 0; i < loop; i++);

}

/************************************************************/
/* Main Program */
/************************************************************/
void main ( void )
{
	char rtn;
	unsigned short i; //,j
	unsigned char W_BUF[128]; 			/* Write Data Area */
	union{
		unsigned char wtdt[8];
		struct{
			unsigned long ad_tmp;		// [0][1][2][3]
			unsigned long restsize;		// [4][5][6][7] ,high->low
		}lw;
	}rcv;

	com_init();

	/* ۸ыN 6msȏR8MƂȂAMJnB*/
	for(i = 0; i < 30000; i++){ 		/* 10000:6.8ms ,30000:20ms */
		_asm NOP						// M܂ŁAŒf[^1bitԑ҂ 1.6us
	};
	trs1byte('A'); 						/* SEND OF OK Code νāiR8)ŎMf */

/*------- Write Address / Size Recive --------*/
LOOP2:
	rtn = rcv1byte(); 					/* Recive 1byte Data -> RAM Area */
	if(rtn != 0x41){
		goto LOOP2;
	}

	delay(WLOOP1);
	trs1byte(OK); 						/* SEND OF OK Code */

	rcvnbyte(rcv.wtdt, 8); 				/* Recive Write Top Address & Size */

	if(rcv.wtdt[3] & 0x7F)
		goto ERRCASE;
	if(rcv.lw.restsize == 0x0000){
		goto ERRCASE;
	}
	trs1byte(OK); 						/* SEND OF OK Code

/*------- 128 byte Flash Memory Write ---------*/
	while(rcv.lw.restsize != 0){
		trs1byte(0x11); 				/* SEND OF Request */
		if(rcv.lw.restsize <= 128){ 	/* Receive WriteData from HOST */
			for (i=0 ; i < 128 ; i++){
				W_BUF[i] = 0xFF;
			}
			rcvnbyte(W_BUF,(unsigned char)rcv.lw.restsize); /* "restsize" byte Receive */
			rcv.lw.restsize = 0;
		}else{
			rcvnbyte(W_BUF, 128);		/* 128byte Receive */
			rcv.lw.restsize -= 128;
		}
		rtn = fwrite128(W_BUF, (unsigned char*)rcv.lw.ad_tmp, 1000);
		if(rtn != OK)
			goto ERRCASE;
	
		rcv.lw.ad_tmp = rcv.lw.ad_tmp + 128;
	}

	trs1byte(0xAA); 					/* SEND OF OK Code */
	TCNTW_0 = 0x5AFF; 					/* INITIZLIZED WDT COUNT */
	TCSRW_0 = 0xA578; 					/* WDT START phi/2 */
	
	while(1);							/* OK End */

/*------- Error Case --------------------------*/
ERRCASE:
	trs1byte(NG);
	while(1);
}

/************************************************************/
/* Flash Memory 128 byte Write */
/************************************************************/
char fwrite128( unsigned char *wt_buf, unsigned char *wt_adr, unsigned short WT_COUNT )
{
	char rtn;
	unsigned short i;
	unsigned short TM;
	unsigned char OWBUFF[128]; 					/* Over Write Data Area */
	unsigned char BUFF[128]; 					/* Retry Write Data Area */

	for (i=0 ; i < 128 ; i++){
		BUFF[i] = wt_buf[i];
	}
	SWE1 = 1; 									/* Set the SWE1 bit */
	delay(WLOOP1);

	rtn = fwritevf((unsigned short *)OWBUFF, 	/* 1st Program Verify */
					(unsigned short *)BUFF,
					(unsigned short *)wt_buf,
					(unsigned short *)wt_adr);
	
	if(rtn == NG){ 								/* 1st Verify END */
		TM = TIME30; 							/* Input P Palse(30 usec) */
		for(i = 0; i < WT_COUNT; i++){
			fwrite_rename(BUFF,wt_adr,TM); 		/* Input P Palse(10,30,200 usec) */
			rtn = fwritevf((unsigned short *)OWBUFF,
				(unsigned short *)BUFF,
				(unsigned short *)wt_buf,
				(unsigned short *)wt_adr);

			if(i < OW_COUNT){ 					/* Count Check(additive Write Count) */
				fwrite_rename(OWBUFF,wt_adr,TIME10); 	/* Input P Palse(10 usec) */
			}
			else{
				TM = TIME200; 					/* Input P Palse(200 usec) */
			}
			if(rtn != NG){
				break; 							/* NG Write Over Error */
			}
		}
	}
	SWE1 = 0; 									/* Clear the SWE1 bit */
	delay(WLOOP100);
	
	return(rtn);
}

/************************************************************/
/* Flash Memory Write */
/************************************************************/
void fwrite_rename( unsigned char *buf, unsigned char *w_adr, unsigned short ptime )
{
	unsigned char i;
	
	for(i = 0; i < 128; i++){ 	/* 128 byte repeat */
		w_adr[i] = buf[i]; 		/* Rewrite data dummy write */
	}

	TCSRW_0 = 0xA579; 			/* WDT START phi/64 */
	PSU1 = 1; 					/* Set the PSU1 bit */
	delay(WLOOP50);
	
	P1 = 1; 					/* Set the P1 bit */
	delay(ptime);
	
	P1 = 0; 					/* Clear the P1 bit */
	delay(WLOOP5);
	
	PSU1 = 0; 					/* Clear the PSU1 bit */
	delay(WLOOP5);
	
	TCSRW_0 = 0xA500; 			/* WDT STOP */
}

/************************************************************/
/* Flash Memory Verify */
/************************************************************/
char fwritevf ( unsigned short *owbuff, unsigned short *buff , unsigned short *wvf_buf, unsigned short
*wvf_adr )
{
	char rtn;
	unsigned char j;
	unsigned short tmp;
	unsigned char *wad;

	PV1 = 1; 							/* Set the PV1 bit */
	delay(WLOOP4);
	
	wad = (unsigned char*)wvf_adr;
	for(j = 0; j < 128/2; j++){
		wad[j*2] = 0xFF; 				/* Dummy Write */
		delay(WLOOP2);
		owbuff[j] = buff[j] | wvf_adr[j];
		tmp = ~wvf_adr[j];
		buff[j] = tmp | wvf_buf[j];
		tmp = tmp & wvf_buf[j]; 		/* Error Check */
		if(tmp != 0)
			break;
		}

		PV1 = 0; 						/* PV1 bit Clear */
		delay(WLOOP2);
		
		if(tmp == 0){
			rtn = OK;
			for(j = 0; j < 128/2; j++){ /* 128 byte OK? */
				if(buff[j] != 0xFFFF){ 	/* Error Check */
					rtn = NG;
					break;
				}
			}
		}
		else{
			rtn = WNG; 					/* Write Error */
		}
		return(rtn);
}



/************************************************************/
/* Communication Initialize */
/************************************************************/
void com_init( void )
{
	// SCI2ްӰޒʐM
	MSTPCRB &= 0xDF; 		/* SCI2;bit5 module stop mode is cleared */
	SMR_2 =0;
	SCR_2 =0;
	BRR_2 =19;
	_asm NOP				// M܂ŁAŒf[^1bitԑ҂ 1.6us
	SSR_2 &= 0xC7; 			/* ORER,FER,PER=0 */
	SCR_2 = 0x30; 			/* TE=1,RE=1 */
	}

/************************************************************/
/* Receive 1 byte : SCSI2 */
/************************************************************/
unsigned char rcv1byte ( void )
{
	unsigned char tmp;

	do{
		tmp = RDRF_2;				/* Receive Data Register Full */
		if(SSR_2 & 0x38){ 			/* ORER/FER/PER = 1 ? */
			SSR_2 &= ~0x38; 		/* ORER/FER/PER tONA */
			tmp = RDR_2;			// dummy read
			RDRF_2 &=0;				// clear
			RE_2 =1;				// M
		}
	}while(tmp == 0); 				/* End Serial Receiving */
	
	tmp = RDR_2; 					/* Read Receive data */
	RDRF_2 = 0; 					/* Clear RDRF bit */

	return(tmp);
}

/************************************************************/
/* Receive N byte */
/************************************************************/
void rcvnbyte ( unsigned char *ram, unsigned char dtno )
{
	while(dtno--){ 				/* dtno = 0 ? */
		*ram = rcv1byte(); 		/* 1byte Receive Data -> RAM */
		*ram++;
	}
}

/************************************************************/
/* Transmit 1 byte : SCI2 */
/************************************************************/
void trs1byte ( unsigned char tdt )
{
	while(TDRE_2 == 0); /* End Serial Transmitting */
	TDR_2 = tdt;
	TDRE_2 = 0;
	while(TEND_2 == 0); /* End Serial Transmitting */
}

/************************************************************/
/* Transmit N byte */
/************************************************************/
void trsnbyte ( unsigned char *tdt, unsigned char dtno )
{
	while(dtno--){
		while(TDRE_2 == 0); /* End Serial Transmitting */
		TDR_2 = *tdt;
		TDRE_2 = 0;
		*tdt++;
	}
	while(TEND_2 == 0); 	/* End Serial Transmitting */
}

