
/***********************************************************************/
/*                                                                     */
/*  FILE        :LCD.c 				  	                               */
/*  DATE        :Tue, Sep 28, 2004                                     */
/*  DESCRIPTION :LCD Main Program and library                          */
/*  CPU TYPE    :R8C/15                                                */
/*                                                                     */
/***********************************************************************/

#include	"sfr_r815.h"


///@vg^Cv  /////
void ltostring(int digit, unsigned long data, char *buffer);
void delay(volatile long usec);	// ϲۂmsɕύX 3.8us
void lcd_out(char code, char flag);
void lcd_cmd(char cmd);


///////////////////////
//LCDpCPU֐
void Init_LCD(void)
{
	/// |[g̓o̓[hݒ
	pd1 = 0x0F;						//4rbgo
	p1 = 0;							//lLowo
	pd3_3 = 1;						// p3_3 output 051031
	pd3_4 = 1;

}

/////// ֐
void lcd_init(void)
{
	delay(20);					//original PϲۂmsύX 20msec wait
	lcd_out(0x03, 1);			//8bit mode set
	delay(5);					//5msec wait
	lcd_out(0x03, 1);			//8bit mode set
	delay(1);
	lcd_out(0x03, 1);			//8bit mode set
	delay(1);
	lcd_out(0x02, 1);			//4bit mode set
	delay(1);
	lcd_cmd(0x2C);				//DL=0 4bit mode
	lcd_cmd(0x08);				//display off C=D=B=0
	lcd_cmd(0x0E);				//display on D=B=1 C=0
	lcd_cmd(0x06);				//entry I/D=1 S=0
	lcd_cmd(0x01);				//all clear
}


///////////////////////////////////////////////////////////
//  t\퐧䃉Cu
//  ֐͈ȉ
//    lcd_init()    ------- 
//    lcd_cmd(cmd)  ------- R}ho
//    lcd_data(chr) ------- P\o
//    lcd_clear()   ------- S
//    lcd_str(char *str)--- \
///////////////////////////////////////////////////////////

///// l當ɕϊ(long^j
void ltostring(int digit, unsigned long data, char *buffer)
{
	int i;
	buffer += digit;							//̍Ō
	*buffer = 0;								//\0ۑ
	for(i=digit; i>0; i--)						//ŉʌʂ
	{	
		buffer--;								//|C^[P
		*buffer = (data % 10) + '0';			//̌l𕶎ɂĊi[
		data = data / 10;						//-1
	}
}


//////// 1usecfBC֐
void delay(volatile long usec)	// ϲۂmsɕύX 3.8us
{
	usec = (usec * 400) ;
	while(usec--){
	}
}

//////// f[^o̓Tu֐
void lcd_out(char code, char flag)
{
	p1 = code & 0x0F;			//o̓f[^ʂSrbg
	if (flag == 0){				//\f[^R}h
		p3_4 =1;				//\f[^̏ꍇRS=1
	}else{
		p3_4 =0;				//R}hf[^̏ꍇRS=0
	}
	asm("NOP");					//NOP@XL[m		
	p3_3 =1;					//STB ON
	asm("NOP");
	asm("NOP");					//pXm230nsecȏ
	asm("NOP");
	asm("NOP");
	p3_3 =0;					//STB OFF
}

//////// P\֐
void lcd_data(char asci)
{
	lcd_out(asci>>4, 0);		//ʂSrbgo
	lcd_out(asci, 0);			//ʂSrbgo
	delay(1);					//msɕϊ 50sec҂
}
/////// R}ho͊֐
void lcd_cmd(char cmd)
{
	lcd_out(cmd>>4, 1);			//ʂSrbgo
	lcd_out(cmd, 1);			//ʂSrbgo
	if((cmd == 0x01) || (cmd == 0x02))
		delay(2);				//Pms 2msec҂
	else
		delay(1);				//Pms 50usec҂
}

/////// S֐
void lcd_clear()
{
	lcd_cmd(0x01);				//R}ho
}

/////// o͊֐
void lcd_str(char *str)
{
	while(*str != 0x00)			//̏I蔻
	{
		lcd_data(*str);			//Po
		str++;					//|C^{P
	}
}
// =================================================================
/////// 1LN^->16iϊ֐  070228
void lcd_hexdata(char asci)
{
	if (!asci){
		lcd_data('0');				//Po
	}else if (asci <= 9){
		lcd_data('0'+asci);
	}else{
		lcd_data('A'+asci -10);
	}
}

/////// 1LN^10i2ɕA\  070228
void binto16(char asci)
{
	lcd_hexdata(asci >>4);			// 1 10il16i\
	lcd_hexdata(asci % 16);			// 2
}

/////// oCi->16iϊ֐  070228
void lcd_binto16(char *str, char num)
{
	int i;

	for (i=0; i< num; i++){
		binto16(*str);				//Po
		str++;						//|C^{P
	}
}
// =================================================================


